test -z "$bindir" && bindir="@bindir@"
test -z "$mandir" && mandir="@mandir@"
test -z "$sysconfdir" && sysconfdir="@sysconfdir@"
-test -z "$pagerpath" && pagerpath="@pagerpath@"
+test -z "$supported_locks" && supported_locks="@supported_locks@"
test -z "$MULTIBYTE_ENABLED" && MULTIBYTE_ENABLED="@MULTIBYTE_ENABLED@"
-export MH_TEST_DIR auxexecdir bindir mandir sysconfdir pagerpath
-export MULTIBYTE_ENABLED
+test -z "$ICONV_ENABLED" && ICONV_ENABLED="@ICONV_ENABLED@"
+export MH_TEST_DIR auxexecdir bindir mandir sysconfdir
+export MULTIBYTE_ENABLED ICONV_ENABLED
test -z "$MH_INST_DIR" && MH_INST_DIR="${MH_TEST_DIR}/inst"
export MH_INST_DIR
-unset MHBUILD MHCONTEXT MHMTSUSERCONF MHN MHSHOW MHSTORE MHTMPDIR
-unset MHLDEBUG MHPDEBUG MHWDEBUG MM_CHARSET
+unset MHBUILD MHCONTEXT MHMTSUSERCONF MHN MHSHOW MHSTORE
+unset MHLDEBUG MHPDEBUG MHWDEBUG MM_CHARSET PAGER
+
+#### Use a test dir for tmp files when MHTMPDIR applies.
+MHTMPDIR=$MH_TEST_DIR/Mail
+export MHTMPDIR
output_md5()
{
#### the same line, the caller needs to add it. This avoids
#### differences due to a leading '*' binary file indicator, for
#### text files, on some platforms (Cygwin).
- @MD5SUM@ $* | @MD5FMT@ | cut -d ' ' -f 1
+ @MD5SUM@ $* | @MD5FMT@ | awk '{print $1}'
}
#### Use built-in $((...)) in test suite if shell supports it.
D=.
fi
if [ -f "$D/$PROG" -a -x "$D/$PROG" ]; then
- printf "$D/$PROG"
+ printf '%s\n' "$D/$PROG"
break
fi
done
}
# Some stuff for doing silly progress indicators
-progress_update ()
-{
- THIS="$1"
- FIRST="$2"
- LAST="$3"
- arith_eval $LAST - $FIRST; RANGE=$arith_val
- arith_eval $THIS - $FIRST; PROG=$arith_val
- # this automatically rounds to nearest integer
- arith_eval 100 \* $PROG / $RANGE; PERC=$arith_val
- # note \r so next update will overwrite
- printf "%3d%%\r" $PERC
-}
+if [ -t 1 ] ; then
+ progress_update ()
+ {
+ THIS="$1"
+ FIRST="$2"
+ LAST="$3"
+ arith_eval $LAST - $FIRST; RANGE=$arith_val
+ arith_eval $THIS - $FIRST; PROG=$arith_val
+ # this automatically rounds to nearest integer
+ arith_eval 100 \* $PROG / $RANGE; PERC=$arith_val
+ # note \r so next update will overwrite
+ printf '%3d%%\r' $PERC
+ }
-progress_done ()
-{
- printf "100%%\n"
-}
+ progress_done ()
+ {
+ printf '100%%\n'
+ }
+else
+ # don't emit anything if stdout is not connected to a tty.
+ progress_update ()
+ {
+ :
+ }
+ progress_done ()
+ {
+ :
+ }
+fi
check_for_hard_links () {
set +e
set -e
}
+#### Filter that squeezes blank lines, partially emulating GNU cat -s,
+#### but sufficient for our purpose.
+#### From http://www-rohan.sdsu.edu/doc/sed.html, compiled by Eric Pement.
+squeeze_lines() {
+ sed '/^$/N;/\n$/D'
+}
+
+#### Filter that converts non-breakable space U+00A0 to an ASCII space.
+prepare_space() {
+ sed 's/'"`printf '\\302\\240'`"'/ /g'
+}
+
#### check() requires two arguments, each the name of a file to be
#### diff'ed.
-#### If the same, the second file is removed. And the first file is
-#### removed unless the optional third argument has a value of
-#### 'keep first'.
+#### If the contents are same, the second file is removed. And the
+#### first file is removed unless there's an optional argument with
+#### a value of 'keep first'.
#### If different, global variable "failed" is incremented.
+#### If there's an optional 'ignore space' argument, spacing differences
+#### will not be considered signficant, emulating GNU diff -w. It
+#### is assumed that the first file has already been run through
+#### prepare_space.
check() {
- #### POSIX diff should support -c.
- if diff -c "$1" "$2"; then
- test $# -lt 3 -o "$3" != 'keep first' && rm -f "$1"
- rm -f "$2"
+ first=$1; shift
+ second=$1; shift
+ keepfirst=
+ ignorespace=
+ while [ $# -gt 0 ]; do
+ case $1 in
+ 'keep first') keepfirst=1 ;;
+ 'ignore space') ignorespace=1 ;;
+ *) echo "$0: invalid check() argument \"$1\" in test suite" >&2 ;;
+ esac
+ shift
+ done
+
+ success=
+ if [ "$ignorespace" ]; then
+ #### POSIX diff should support -b.
+ prepare_space <"$second" | diff -b "$first" - >/dev/null && success=1
else
- echo "$0: test failed, outputs are in $1 and $2."
- failed=`expr ${failed:-0} + 1`
+ cmp -s "$first" "$second" && success=1
fi
+
+ if [ "$success" ]; then
+ [ "$keepfirst" ] || rm -f "$first"
+ rm -f "$second"
+ else
+ echo
+ #### POSIX diff should support -c.
+ diff -c "$first" "$second" || true
+ echo
+ echo "$0: test failed, outputs are in $first and $second."
+ failed=`expr ${failed:-0} + 1`
+ #### Set return status of the function.
+ [ $failed -eq 0 ]
+ fi
+}
+
+
+#### Shortcut to enable use of valgrind: set NMH_VALGRIND environment
+#### variable (to anything) so run_* will use valgrind.
+if [ "${NMH_VALGRIND}" -a -z "${NMH_TEST_PREFIX}" ]; then
+ #### Need absolute path to valgrind.supp in case the test does a cd.
+ NMH_TEST_PREFIX="valgrind --quiet --error-exitcode=1 \
+ --suppressions=`cd ${srcdir} && pwd`/test/valgrind.supp"
+fi
+
+#### Run test under another program by setting NMH_TEST_PREFIX
+#### environment variable to, e.g., 'valgrind --quiet'.
+run_prog() {
+ case $1 in
+ #### Don't run valgrind on shell built-in.
+ eval\ *) "$@" ;;
+ *) ${NMH_TEST_PREFIX} "$@" ;;
+ esac
}
+
#### run_test() requires two arguments, the first is a program and
#### arguments, the second is its expected one-line output string.
#### If the actual output does not match that string:
#### if there is an optional third argument, it is used in the error message.
run_test() {
set +e
- actual_output=`$1 2>&1`
+ case $1 in
+ #### Don't run valgrind on shell built-in.
+ eval\ *) actual_output=`$1 2>&1` ;;
+ *) actual_output=`${NMH_TEST_PREFIX} $1 2>&1` ;;
+ esac
set -e
if test x"$actual_output" != x"$2"; then
echo "$0: ${3:-\"$1\"} expected:" 1>&2
{
MH="${MH_TEST_DIR}/Mail/.mh_profile"
MHMTSCONF="${MH_INST_DIR}${sysconfdir}/mts.conf"
- PATH="${MH_INST_DIR}${bindir}:${PATH}"
MH_LIB_DIR="${MH_INST_DIR}${auxexecdir}"
- export MH MHMTSCONF MH_LIB_DIR PATH
+ export MH MHMTSCONF MH_LIB_DIR
#
# Only install once
#### so that we use fakesmtp.
#### And set up the maildrop in the test directory so tests don't
#### use the user's real maildrop.
+ #### test-slocal needs to look at the original mts.conf, so save it.
+ mv -f "${MHMTSCONF}" "${MHMTSCONF}.old"
sed -e 's/mts: *.*/mts: smtp/' \
-e "s%mmdfldir: *.*%mmdfldir: ${MH_TEST_DIR}/Mail%" \
-e 's%mmdflfil: *.*%mmdflfil: maildrop%' \
- "${MHMTSCONF}" >"${MHMTSCONF}.new"
- mv -f "${MHMTSCONF}.new" "${MHMTSCONF}"
+ "${MHMTSCONF}.old" >"${MHMTSCONF}"
fi
+ #### On Solaris, must set PATH after the install!
+ PATH="${MH_INST_DIR}${bindir}:${PATH}"
+ export PATH
+
# clean old test data
trap "rm -rf '$MH_TEST_DIR/Mail'" 0
# setup test data
- mkdir "$MH_TEST_DIR/Mail" || exit 1
+ mkdir -p "$MH_TEST_DIR/Mail" || exit 1
cat > "$MH" <<EOF || exit 1
Path: ${MH_TEST_DIR}/Mail
buildmimeproc: ${MH_INST_DIR}${bindir}/mhbuild
for f in MailAliases components digestcomps distcomps forwcomps mhl.body \
mhl.digest mhl.format mhl.forward mhl.headers mhl.reply \
mhn.defaults rcvdistcomps replcomps replgroupcomps scan.MMDDYY \
- scan.YYYYMMDD scan.default scan.mailx scan.nomime scan.size \
- scan.time scan.timely scan.unseen
+ scan.YYYYMMDD scan.curses scan.default scan.highlighted scan.mailx \
+ scan.nomime scan.size scan.time scan.timely scan.unseen
do
cp "${MH_INST_DIR}${sysconfdir}/${f}" "${MH_TEST_DIR}/Mail" || exit 1
done
From: Test$i <test$i@example.com>
To: Some User <user@example.com>
Date: Fri, 29 Sep 2006 00:00:00
+Message-Id: $i@test.nmh
Subject: Testing message $i
This is message number $i